#include <stdio.h>
#include <string.h>

#include "slang.h"
#include "slwdg.h"
#include "_slwdg.h"


static void draw_button (SLWdg_Type *ip)
{
   int len;
   
   if (ip->label == NULL) return;
   
   len = strlen (ip->label);
   
   SLsmg_gotorc (ip->y, ip->x);
   if (ip == ip->parent->current) SLsmg_set_color (ACTIVE_BUTTON_COLOR);
   else if (SLtt_Use_Ansi_Colors) SLsmg_set_color (BUTTON_COLOR);
  
  
   if (SLtt_Use_Ansi_Colors)
     {
	if (len <= 4)
	  SLsmg_printf ("  %s  ", ip->label);
	else if (len <= 7)
	  SLsmg_printf (" %s ", ip->label);
	else
	  SLsmg_printf ("%s", ip->label);
     }
   else
     {
	if (len <= 4)
	  SLsmg_printf ("[- %s -]", ip->label);
	else
	  SLsmg_printf ("[%s]", ip->label);
     }
   
   SLsmg_gotorc (ip->y, ip->x + 2);
   SLsmg_set_color (0);
}

static int button_focus_proc (SLWdg_Type *ip, int keysym)
{
   switch (keysym)
     {
      default: 
	return -1;
	
      case KEY_MOUSE0:
      case KEY_MOUSE1:
      case KEY_MOUSE2:
	if (ip != SLwdg_find_widget_at_xy (ip, SLWdg_Mouse_X, SLWdg_Mouse_Y))
	  return -1;
	/* drop */
      case KEY_RETURN:
	(void) SLwdg_perform_callback (ip);
	break;
     }
   return 0;
}

int SLwdg_init_button (SLWdg_Type *ip)
{
   ip->draw = draw_button;
   ip->focus_proc = button_focus_proc;
   ip->height = 1;
   if (ip->label != NULL)
     {
	ip->width = 4 + strlen (ip->label);
     }
   return 0;
}
