#include <stdio.h>

#include "slang.h"
#include "slwdg.h"


static void quit (void)
{
   SLwdg_end ();
   exit (0);
}

static SLang_Intrin_Fun_Type Demo_Intrinsics [] =
{
   MAKE_INTRINSIC_0("quit", quit, VOID_TYPE),
   SLANG_END_TABLE
};


int main (int argc, char **argv)
{
   
   char *file;

   /* parse command line arguments */
   if (argc != 2) 
     {
	fprintf (stderr, "Usage: %s FILENAME\n", argv[0]);
	exit (-1);
     }
   
   file = argv[1];
   
   if ((-1 == SLang_init_slang ())     /* basic interpreter functions */
       || (-1 == SLang_init_slmath ()) /* sin, cos, etc... */
       || (-1 == SLang_init_slunix ()) /* common unix system calls (stat, etc) */
       || (-1 == SLang_init_slfile ()) /* file I/O */
       || (-1 == init_SLwdg ())
       || (-1 == SLadd_intrin_fun_table (Demo_Intrinsics, NULL)))
     {
	fprintf(stderr, "Unable to initialize S-Lang.\n");
	exit (1);
     }

   /* Turn on debugging */
   SLang_Traceback = 1;
   
   SLwdg_initialize (0);
   
   /* Now load an initialization file and exit */
   SLang_load_file (file);
   
   SLwdg_end ();
   return (SLang_Error);
}
