#include <stdio.h>
#include <string.h>

#include "slang.h"
#include "slwdg.h"
#include "_slwdg.h"

static void compute_box_size (char *msg, int *dr, int *dc)
{
   char *p, ch;
   int x = 0, y = 0;
   int xmax = 0;
   
   p = msg;
   while (1)
     {
	ch = *p++;
	if ((ch == 0) || (ch == '\n'))
	  {
	     if (x > xmax) xmax = x;
	     y++;
	     if (ch == 0) break;
	     x = 0;
	  }
	else x++;
     }
   *dr = y;
   *dc = xmax;
}


/* The message is the id of the thing we want to kill. */
static int message_ok (int id, int msg, char *str)
{
   SLwdg_destroy_widget (msg);
   return 0;
}

int SLwdg_message (char *text)
{
   int dr, dc, r, c;
   int msgid, okid;
   
   if (SLwdg_TT_Initialized == 0)
     {
	fprintf (stdout, "%s\n", text);
	return 0;
     }
   

   compute_box_size (text, &dr, &dc);
   dc += 4;
   dr += 4;
   
   r = (SLWdg_Root_Widget->height - dr) / 2;
   c = (SLWdg_Root_Widget->width - dc) / 2;
   
   if (-1 == (msgid = SLwdg_define_widget (0, COMBO_BOX, 
					      NULL, NULL, NULL,
					      c, r, dc, dr,
					      0)))
     return -1;
   
   SLwdg_define_widget (msgid, STATIC_TEXT, 
			   text,
			   NULL,
			   NULL,
			   2, 1, dc, dr,
			   1);
   if (-1 == (okid = SLwdg_define_widget (msgid, BUTTON,
					      "Ok", NULL, 
					     "Press Return to continue.",
					     dc / 2 - 2, 
					     dr - 2, 
					     4, 1, 
					     1)))
     {
	SLwdg_destroy_widget (msgid);
	return -1;
     }
   
   SLwdg_set_callback (okid, message_ok, msgid, NULL);
   SLwdg_popup_widget (msgid, 1);
   SLwdg_take_input (msgid);
   return 0;
}

static int Yes_No_Cancel_Result;
static int Yes_No_Cancel_Id;

static int yes_no_cancel (int id, int msg, char *str)
{
   Yes_No_Cancel_Result = msg;
   SLwdg_destroy_widget (Yes_No_Cancel_Id);
   return 0;
}

int SLwdg_get_yes_no_cancel (char *text)
{
   int dr, dc, r, c, len;
   int noid, canid, yesid;
   
   compute_box_size (text, &dr, &len);
   dc = len + 4;
   dr += 4;
   if (dc < 40) dc = 40;
   
   r = (SLWdg_Root_Widget->height - dr) / 2;
   c = (SLWdg_Root_Widget->width - dc) / 2;
   
   if (-1 == (Yes_No_Cancel_Id = SLwdg_define_widget (0, COMBO_BOX, 
					      NULL, NULL, NULL,
					      c, r, dc, dr,
					      0)))
     return -1;
   
   SLwdg_define_widget (Yes_No_Cancel_Id, STATIC_TEXT, 
			   text,
			   NULL,
			   NULL,
			   (dc - len)/2, 1, len, dr,
			   1);
   
   if (-1 == (yesid = SLwdg_define_widget (Yes_No_Cancel_Id, BUTTON,
					      "Yes", NULL, 
					     NULL,
					     2,
					     dr - 2, 
					     4, 1, 
					     1)))
     {
	SLwdg_destroy_widget (Yes_No_Cancel_Id);
	return -1;
     }
   
   if (-1 == (noid = SLwdg_define_widget (Yes_No_Cancel_Id, BUTTON,
					      "No", NULL,
					     NULL,
					     dc / 2 - 3, 
					     dr - 2, 
					     4, 1, 
					     1)))
     {
	SLwdg_destroy_widget (Yes_No_Cancel_Id);
	SLwdg_destroy_widget (yesid);
	return -1;
     }
   if (-1 == (canid = SLwdg_define_widget (Yes_No_Cancel_Id, BUTTON,
					      "Cancel", NULL, 
					     NULL,
					     dc - 2 - 8,
					     dr - 2,
					     4, 1, 
					     1)))
     {
	SLwdg_destroy_widget (Yes_No_Cancel_Id);
	SLwdg_destroy_widget (yesid);
	SLwdg_destroy_widget (noid);
	return -1;
     }
   
   SLwdg_set_callback (yesid, yes_no_cancel, 1, NULL);
   SLwdg_set_callback (noid, yes_no_cancel, 0, NULL);
   SLwdg_set_callback (canid, yes_no_cancel, -1, NULL);
   SLwdg_popup_widget (Yes_No_Cancel_Id, 1);
   SLwdg_take_input (Yes_No_Cancel_Id);
   return Yes_No_Cancel_Result;
}

   
