% This file implements a yes/no widget

variable YN_Widget = slwdg_define_widget (0, 
					  COMBO_BOX,
					  "", "", "",
					  30, 8, 40, 10,
					  0);

variable YN_Yes_Button = slwdg_define_widget (YN_Widget, 
					      BUTTON,
					      "Yes", "", "",
					      5, 5, 0, 0,
					      1);

variable YN_No_Button = slwdg_define_widget (YN_Widget,
					     BUTTON,
					     "No", "", "",
					     25, 5, 0, 0,
					     1);

variable YN_Static_Text = slwdg_define_widget (YN_Widget,
					       STATIC_TEXT,
					       "", "", "",
					       10, 2, 0, 0,
					       1);

variable YN_Response = -1;

define yn_callback (id, msg)
{
   YN_Response = msg;
   slwdg_popup_widget (YN_Widget, 0);
   return 0;
}

slwdg_set_callback (YN_Yes_Button, "yn_callback", 1);
slwdg_set_callback (YN_No_Button, "yn_callback", 0);


define get_yes_no (question)
{
   variable x, y, dx, dy;
   variable width;
   variable height;
   variable len;
   
   len = strlen (question);
   width = len;
   if (width < 20) width = 20;
   width += 4;
   height = 6;
   
   (,, dx, dy) = slwdg_get_size (0);
   x = (dx - width) / 2;
   y = (dy - height) / 2;

   slwdg_set_size (YN_Widget, x, y, width, height);
   slwdg_set_size (YN_Static_Text, (width - len) / 2, 2, 0, 0);
   slwdg_set_size (YN_Yes_Button, 2, 4, 0, 0);
   slwdg_set_size (YN_No_Button, width - 10, 4, 0, 0);

   slwdg_set_text (YN_Static_Text, question);
   
   slwdg_popup_widget (YN_Widget, 1);
   slwdg_take_input (YN_Widget);
   return YN_Response;
}



